﻿var $, ko, bs;
var selReg;
var baseUrl;
var catCache, dealCache, dealExpCache, dealActCache;
var selData, totExpDealPg, expDealPg = 1;
var userInfo, myCart, myFav;
var sFlagActive = false;
var doCheckout = false;
var isAppBsy = false;
var isPMode = false;
var pathVar;
var androidSenderID = '158709849244';
var androidDeviceID;
var SignIn;
var AppVersion = '0.1.1';
var versionChecked = false;

require.config({
    baseUrl: '',
    paths: {
        jquery: "resources/js/jquery-2.1.3.min",
        knockout: "resources/frameworks/knockout-3.2.0",
        busServ: "serv",
        kValid: "resources/frameworks/knockout.validation-2.0.0",
        uiBlocker: "resources/js/jquery.blockUI",
        timer : "resources/js/timer_countdown.min",
		sammy : "resources/js/sammy-latest.min"
    }
});

var checkConnection = function () {
    var networkState = navigator.connection.type;

    var states = {};
    states[Connection.UNKNOWN]  = 'Unknown connection';
    states[Connection.ETHERNET] = 'Ethernet connection';
    states[Connection.WIFI]     = 'WiFi connection';
    states[Connection.CELL_2G]  = 'Cell 2G connection';
    states[Connection.CELL_3G]  = 'Cell 3G connection';
    states[Connection.CELL_4G]  = 'Cell 4G connection';
    states[Connection.CELL]     = 'Cell generic connection';
    states[Connection.NONE]     = 'No network connection';
	if ((states[networkState]) == states[Connection.NONE]) {
        alert('No Internet Connection. Click OK to exit app');
        navigator.app.exitApp();
    }
}

var onOffline = function () {
	alert('No Internet Connection. Click OK to exit app');
	navigator.app.exitApp();
}

var successHandler = function (result) {
	//alert('result = ' + result);
};
var errorHandler = function (error) {
	alert('error = ' + error);
};	
var onNotification = function (e) {
	switch( e.event )
	{
	case 'registered':
		if ( e.regid.length > 0 )
		{
			if (androidDeviceID) {
				//alert('already registered');
			}
			else {
				androidDeviceID = e.regid;
				localStorage.setItem('deviceID', e.regid);
				bs.registerDevice(e.regid);
			}
		}
	break;

	case 'message':
		if ( e.foreground )
		{
			var soundfile = e.soundname || e.payload.sound;
			var my_media = new Media(pathVar+ soundfile);
			my_media.play();
			//alert('foreground');
		}
		else
		{  
			if ( e.coldstart )
			{
				location.hash = "/nearme";
				//alert('coldstart');
			}
			else
			{
				
			}
		}
		alert(e.payload.message);
		//alert(e.payload.msgcnt);
	   //$("#app-status-ul").append('<li>MESSAGE -> MSG: ' + e.payload.message + '</li>');
		   //Only works for GCM
	   //$("#app-status-ul").append('<li>MESSAGE -> MSGCNT: ' + e.payload.msgcnt + '</li>');
	   //Only works on Amazon Fire OS
	   //$status.append('<li>MESSAGE -> TIME: ' + e.payload.timeStamp + '</li>');
	break;

	case 'error':
		//$("#app-status-ul").append('<li>ERROR -> MSG:' + e.msg + '</li>');
		//alert(e.msg);
	break;

	default:
		//$("#app-status-ul").append('<li>EVENT -> Unknown, an event was received and we do not know what it is</li>');
		//alert('Unknown, an event was received and we do not know what it is');
	break;
  }
};

var onDeviceReady = function () {
	if (navigator.notification) {
		window.alert = function (message) {
		  navigator.notification.alert(
			  message,    // message
			  null,       // callback
			  "LOOTLO.PK", // title
			  'OK'        // buttonName
		  );
		};
	}
	window.analytics.startTrackerWithId('UA-42224673-3');
	window.addEventListener("offline", onOffline, false);
	checkConnection();
	/*pushNotification = window.plugins.pushNotification;
	if (localStorage.getItem('deviceID')){
		androidDeviceID = localStorage.getItem('deviceID');
	}else{
		if ( device.platform == 'android' || device.platform == 'Android' || device.platform == "amazon-fireos" ){
			pushNotification.register(
			successHandler,
			errorHandler,
			{
				"senderID":androidSenderID,
				"ecb":"onNotification"
			});
		} else {
			pushNotification.register(
			tokenHandler,
			errorHandler,
			{
				"badge":"true",
				"sound":"true",
				"alert":"true",
				"ecb":"onNotificationAPN"
			});
		};
	}
		// START OF CODE FOR BACKGROUND GEOLOCATION TRACKING
    window.navigator.geolocation.getCurrentPosition(function(location) {
        console.log('Location from Phonegap');
    });
    var bgGeo = window.plugins.backgroundGeoLocation;
    var yourAjaxCallback = function(response) {
        ////
        // IMPORTANT:  You must execute the #finish method here to inform the native plugin that you're finished,
        //  and the background-task may be completed.  You must do this regardless if your HTTP request is successful or not.
        // IF YOU DON'T, ios will CRASH YOUR APP for spending too much time in the background.
        //
        //
		console.log(response);
        bgGeo.finish();
    };

    var callbackFn = function(location) {
        console.log('[js] BackgroundGeoLocation callback:  ' + location.latitude + ',' + location.longitude);
        // Do your HTTP request here to POST location to your server.
        yourAjaxCallback.call(this);
    };

    var failureFn = function(error) {
        console.log('BackgroundGeoLocation error');
    }

    // BackgroundGeoLocation is highly configurable.
    bgGeo.configure(callbackFn, failureFn, {
		
        url: 'http://lootlo.pk/services/geolocation_service.php', // <-- Android ONLY:  your server url to send locations to
        params: {
            device_id: androidDeviceID,
            foo: 'bar'   
        },
        desiredAccuracy: 10,
        stationaryRadius: 2500,
        distanceFilter: 2500,
        notificationTitle: 'Background tracking', // <-- android only, customize the title of the notification
        notificationText: 'ENABLED', // <-- android only, customize the text of the notification
        activityType: 'AutomotiveNavigation',
        debug: false, // <-- enable this hear sounds for background-geolocation life-cycle.
        stopOnTerminate: false // <-- enable this to clear background location settings when the app terminates
    });
    // Turn ON the background-geolocation system.  The user will be tracked whenever they suspend the app.
    bgGeo.start();*/
}

window.addEventListener("deviceready", onDeviceReady, true);

requirejs(['jquery', 'knockout', 'busServ', 'kValid', 'sammy', 'uiBlocker', 'timer'], function (jq, knockout, busServ, kValid, Sammy) {
    $ = jq;
    ko = knockout;
    bs = busServ;
	isLoggedIn = ko.observable(false);
	pathVar = window.location.href.split('www')[0] + 'www/';
	
	//Routing Starts Here
	Sammy(function() {
        this.get('#/register', function() {
			regView();
			window.analytics.trackView('Register');
        });
		this.get('#/signin', function() {
			signInView();
			window.analytics.trackView('Signin');
        });
		this.get('#/forgot-password', function() {
			forgotPwdView();
			window.analytics.trackView('Forgot Password');
        });
		this.get('#/howitworks', function() {
			howWorksView();
			window.analytics.trackView('How it Works');
        });
		this.get('#/postdealview', function() {
			postDealView();
			window.analytics.trackView('Post A Deal');
        });
		this.get('#/contactus', function() {
			contactUsView();
			window.analytics.trackView('Contact Us');
        });
		this.get('#/select-region', function() {
			selRegion();
			window.analytics.trackView('Select City');
        });
		this.get('#/profile', function() {
			myAccount("");
			window.analytics.trackView('My Account');
        });
		this.get('#/deals/:dealType', function() {
			galleryDeal(this.params.dealType);
			window.analytics.trackView('Deals - '+this.params.dealType);
        });
		this.get('#/prod-det/:productId', function() {
			prodDet(this.params.productId);
			window.analytics.trackView('Product Detail - '+this.params.productId);
        });
		this.get('#/my-favorites', function() {
			myFavorites();
			window.analytics.trackView('My Favorites');
        });
		this.get('#/cart', function() {
			manageCart(null);
			window.analytics.trackView('Cart');
        });
		this.get('#/checkout', function() {
			pmtCheckout();
			window.analytics.trackView('Checkout');
        });
		this.get('#/order-online', function() {
			//pmtCheckout();
			window.analytics.trackView('Online Payment');
        });
		this.get('#/order-placed', function() {
			//pmtCheckout();
			window.analytics.trackView('Thankyou Page');
        });
		this.get('#/home', function() {
			myHome();
			window.analytics.trackView('Home');
        });
		this.get('#/categories', function() {
			catView();
			window.analytics.trackView('Categories Listing');
        });
		this.get('#/categories/:catId/:catName', function() {
			catGallery(this.params.catName, this.params.catId);
			window.analytics.trackView('Category - '+this.params.catName);
        });
		this.get('#/nearme', function() {
			nearMe();
			window.analytics.trackView('Near Me');
        });
        this.get('#/edit-address', function() {
			editAddr();
			window.analytics.trackView('Edit Address');
        });
        this.get('#/add-address', function() {
			addAddrVM();
			window.analytics.trackView('Add Address');
        });
        this.get('#/search/:sText', function() {
			searchDeal(this.params.sText);
			window.analytics.trackView('Search Results - '+this.params.sText);
        });
		this.get('#/brand/:brandSlug/:brandName', function() {
			brandDeals(this.params.brandSlug, this.params.brandName);
			window.analytics.trackView('Brand Deals - '+this.params.brandName);
		});
		this.get('#/blocked', function() {
			blockedView();
		});
		this.get("", function () {
			this.app.runRoute("get", "#/blocked");
		});
		this._checkFormSubmission = function(form) {
			return false;
		};
		
    }).run();
	//Routing Ends Here
	if (localStorage.getItem('userInfo')){
		userInfo = localStorage.getItem('userInfo');
		userInfo = JSON.parse(userInfo);
		isLoggedIn(true);
	}
	myFav = new favModel();
	if (localStorage.getItem('myFavorites')){
		source = localStorage.getItem('myFavorites');
		source = JSON.parse(source);
		for (var i = 0; i < source.length; i++) {
			source[i].removeItem = function (datax) {
				myFav.data.remove(this);
				$("#" + this.productId).remove();
				localStorage.setItem('myFavorites', JSON.stringify(myFav.data()));
			};

			source[i].prodDet = function (data) {
				location.hash = "/prod-det/"+this.productId;
			};
			myFav.data().push(source[i]);
		}
	}
	
    $(document).ready(function () {
		
        InitKoExt();
        InitAppConf();
		var city = localStorage.getItem('ll_city');
		if (city){
            bs.servicsOpt.city = city;
        }
        else{
            bs.servicsOpt.city = 'Karachi';
            localStorage.setItem('ll_city', 'Karachi');
        }
        initShared();
        $('.navmenu-nav li').on('click', function(){
	   	 	$(".main-menu").click()
	    });
    });

    SignIn = ko.validatedObservable({
        email: ko.observable("").extend({ required: true, minLength: 3}),
        pwd: ko.observable("").extend({ required: true, minLength: 3}),
        signIn: function () {
            if (SignIn.isValid()) {
                bs.signInMe(this, function (r) {
                    if (r.status == "success") {
                        userInfo = r.user;
						localStorage.setItem('userInfo', JSON.stringify(userInfo));
						isLoggedIn(true);
                        if (!doCheckout) {
                            location.hash = "/profile";
                        } else {
                            location.hash = "/checkout";
                        }

                    } else {
                        spm("Login Failed, Please verify credentials", 'info');
                    }
                });
            } else {
                spm("Please specify valid information", 'danger');
            }
        },
        cancel: function () {
            defGal();
        }
    });
});

var initShared = function () {
	myCart = new ManageCart();
	var objNew = {'isLoggedIn':isLoggedIn,'pathVar':pathVar};
	objNew.dealTypes = ko.observableArray(['Recent', 'Hot', 'Featured']);
	objNew.goToHome = function() { location.hash = "/home"; };
	objNew.goToCart = function() { location.hash = "/cart"; };
	objNew.goToRecentDeals = function() { location.hash = "/deals/Recent";};
	objNew.goToCategories = function() { location.hash = "/categories"; };
	objNew.goToNearMe = function() { location.hash = "/nearme"; };
	objNew.goToRegister = function() { location.hash = "/register"; };
	objNew.goToSignin = function() { location.hash = "/signin"; };
	objNew.goToHowWorks = function() { location.hash = "/howitworks"; };
	objNew.goToPostDeal = function() { location.hash = "/postdealview"; };
	objNew.goToContactUs = function() { location.hash = "/contactus"; };
	objNew.goToSelReg = function() { location.hash = "/select-region"; };
	objNew.goToSignOut = function() { signOut(); };
	objNew.goToMyAccount = function() { location.hash = "/profile"; };
	objNew.goToDeals = function(dealType) { location.hash = "/deals/"+dealType; };
	objNew.searchQuery = ko.observable();
	objNew.goToSearch = function (data, event) {
		if (objNew.searchQuery().length > 3)
			location.hash = "/search/"+objNew.searchQuery(); return false;
	}
	ko.applyBindings(objNew);

	$("#sReg").text(bs.servicsOpt.city);
	$( "#demo-2" ).submit(function( event ) {
	  event.preventDefault();
	  return false;
	});
};

var myHome = function () {	
	bs.getHomeDeals(function (data) {
		$("#contents").load(pathVar+"home.html", function (e) {	
			var brandsVm = new Deal("Recent Deals", data.brands);
			var recentVm = new Deal("Recent Deals", data.recent);
			var featuredVm = new Deal("Featured Deals", data.featured);
			var hotVm = new Deal("Hot Deals", data.hot);			
			var upLinks = {
				goToCategories : function() { location.hash = "/categories"; },
				goToFavorites : function() { location.hash = "/my-favorites"; },
				goToNearMe : function() { location.hash = "/nearme"; },
			};
			
			ko.cleanNode($("#contents").get(0));
			ko.cleanNode($("#homeBanner").get(0));
			ko.cleanNode($("#upLinks").get(0));
			ko.cleanNode($(".recent").get(0));
			ko.cleanNode($(".featured").get(0));
			ko.cleanNode($(".hot").get(0));
			ko.applyBindings(brandsVm, $("#homeBanner").get(0));
			ko.applyBindings(upLinks, $("#upLinks").get(0));
            ko.applyBindings(recentVm, $(".recent").get(0));
			ko.applyBindings(featuredVm, $(".featured").get(0));
			ko.applyBindings(hotVm, $(".hot").get(0));

			var showLoader = function () {
				var topBanner = new Swiper('.swiper-top', {
					pagination: '.swiper-top-pagination', 
					effect: 'cube',
					grabCursor: true,
					autoplay: 2500,
					loop: true,
					cube: {
						shadow: false,
						slideShadows: false,
					}
				});
				var swiper1 = new Swiper('.swiper-sliders1', {
					pagination: '.swiper-pagination1',
					autoplay: 3000,
					grabCursor: true,
					slidesPerView: 'auto'
				});
				var swiper2 = new Swiper('.swiper-sliders2', {
					pagination: '.swiper-pagination2',
					effect: 'coverflow',
					grabCursor: true,
					centeredSlides: true,
					slidesPerView: 'auto',
					coverflow: {
						rotate: 50,
						stretch: 0,
						depth: 100,
						modifier: 1,
						slideShadows : true
					},
					autoplay: 2500
				});
				var swiper3 = new Swiper('.swiper-sliders3', {
					pagination: '.swiper-pagination3',
					autoplay: 3500,
					grabCursor: true,
					slidesPerView: 'auto'
				});
			};
			setTimeout(showLoader,1000);
			$(".product").click(function (epd) {
                epd.preventDefault();
                var productId = $(this).attr("id");
				location.hash = "/prod-det/"+productId;
            });
			$(".product_brand").click(function (b) {
                b.preventDefault();
                var brandSlug = $(this).attr("id");
				var brandName = $(this).attr("title");
				location.hash = "/brand/"+brandSlug+"/"+brandName;
            });
			
			hLdr();
        });
	});
};
var brandDeals = function(brandSlug, brandName) {
	bs.getBrandDeals(brandSlug, function (data) {
		$("#contents").load(pathVar+"gallery.html", function (e) {
            var vm = new Deal(brandName, data.data);
            vm.dealTypes = ko.observableArray(['Recent', 'Hot', 'Featured']);
			vm.goToDeals = function(dealType) { location.hash = "/deals/"+dealType; };
			vm.goToProduct = function(deal){ location.hash = "/prod-det/"+deal.pId; };
            ko.cleanNode($("#contents").get(0));
            ko.applyBindings(vm, $("#contents").get(0));
            hLdr();
        });
    });
}
var nearMe = function () {
	sLdr();
	//var onSuccess = function(position) {
		//var latLong = position.coords.latitude+','+position.coords.longitude;
		var latLong = '0,0';
		bs.getDealsNearMe(latLong, function (data) {
			$("#contents").load(pathVar+"nearme.html", function (e) {
				data.dealTypes = ko.observableArray(['Recent', 'Hot', 'Featured']);
				data.goToDeals = function(dealType) { location.hash = "/deals/"+dealType; };
				data.goToProduct = function(deal){ location.hash = "/prod-det/"+deal.pId; };
				ko.cleanNode($("#contents").get(0));
				ko.applyBindings(data, $("#contents").get(0));
				hLdr();
			});
		});
	//};
	/*function onError(error) {
		if (error.code == 2){
			alert('Please Enable Location Access in your phone settings to use this feature');
		}else{
			alert('code: '    + error.code    + '\n' +
			  'message: ' + error.message + '\n');
		}
		location.hash = "/home";
	}
	navigator.geolocation.getCurrentPosition(onSuccess, onError);
	*/
}

var galleryDeal = function (selectDealType) {
	bs.getDealsByType(selectDealType, function (data) {
		$("#contents").load(pathVar+"gallery.html", function (e) {
            var dealName;
            switch (selectDealType) {
                case "Featured":
                    selData = data.featured;
                    dealName = "Featured Deals";
                    break;
                case "Hot":
                    selData = data.hot;
                    dealName = "Hot Deals";
                    break;
                case "Recent":
                    selData = data.recent;
                    dealName = "Recent Deals";
                    break;
            }
            var vm = new Deal(dealName, selData);
            vm.dealTypes = ko.observableArray(['Recent', 'Hot', 'Featured']);
			vm.goToDeals = function(dealType) { location.hash = "/deals/"+dealType; };
			vm.goToProduct = function(deal){ location.hash = "/prod-det/"+deal.pId; };
            ko.cleanNode($("#contents").get(0));
            ko.applyBindings(vm, $("#contents").get(0));
            hLdr();
        });
    });
};

var regView = function () {

    $("#contents").load(pathVar+"reg-user.html", function (e, textStatus, req) {
        ko.cleanNode($("#contents").get(0));
        newUserVM = null;
        newUserVM = new NewUserViewModel("", "", "", "", "", "", "");
        ko.applyBindings(newUserVM, $("#contents").get(0));
    });
};

var selReg = function () {
    $("#header").html("<div class=\"logo\"><img src=\""+pathVar+"resources/images/inner-logo.png\"/></div>");
    $("#contents").load(pathVar+"select-region.html", function () {
        $(".select-region").on('click', function (e) {
            e.preventDefault();
            var city = $(this).data("location");
			localStorage.setItem('ll_city', city);
            bs.servicsOpt.city = city;
            initShared();
        });
    });
};

var fbLoginSuccess = function (userData) {
	var fbUserID = userData.authResponse.userID;
	var fbAccessToken = userData.authResponse.accessToken;
	facebookConnectPlugin.api(fbUserID+"/?fields=id,name,email,first_name,gender,last_name,link", ["public_profile","email"],
    function (result) {
		if ('email' in result){
			var userObj = result;
			userObj.thumbnail = "https://graph.facebook.com/"+fbUserID+"/picture";
			bs.connectWithFB(userObj, function (r) {
				if (r.status == "success") {
					userInfo = r.user;
					localStorage.setItem('userInfo', JSON.stringify(userInfo));
					isLoggedIn(true);
					location.hash = "/profile";
				} else {
					alert("Result: " + JSON.stringify(r));
					//spm("Login Failed, Please verify credentials", 'info');
				}
			});
		}else{
			alert('Sorry! Can not connect with facebook because You do not have verified email address on your facebook account');
		}
    },
    function (error) {
        alert("Failed: " + error);
    });
};
var fbLoginError = function (error) {
	alert("" + JSON.stringify(error));
};

var signInView = function () {
    $("#contents").load(pathVar+"signin.html", function (e) {
		var signInObj = new SignIn();
		signInObj.goToRegister = function() { location.hash = "/register"; };
		signInObj.goToForgetPwd = function() { location.hash = "/forgot-password"; };
		signInObj.loginWithFacebook = function () {
			facebookConnectPlugin.login(["public_profile","email"],
				fbLoginSuccess,
				fbLoginError
			);
		};
        ko.cleanNode($("#contents").get(0));
        ko.applyBindings(signInObj, $("#contents").get(0));
    });
};

var forgotPwdView = function () {
    $("#contents").load(pathVar+"forgot-pwd.html", function (e) {
        var vm = new ForgotPwd("");
        ko.cleanNode($("#contents").get(0));
        forgotPwdVM = null;
        forgotPwdVM = vm;
        ko.applyBindings(forgotPwdVM, $("#contents").get(0));

        $("#hlLogin").click(function (el) {
            el.preventDefault();
            location.hash = "/signin";
        });

        $("#hlRegister").click(function (er) {
            er.preventDefault();
            location.hash = "/register";
        });
    });
};

var forgotPwdVM;
var forgotPwdCall = function () {
    forgotPwdVM.email($("#forgotPwdFormEmail").val());
    forgotPwd(forgotPwdVM);
};

var forgotPwd = function (model) {

    bs.forgotPwd(model, function (r) {
        if (r.status == "success") {
            location.hash = "/signin";
            spm(r.message, 'success');
        } else {
            spm(r.error, 'danger');
        }
        hLdr();
    });
};

var updateApp = function () {
	cordova.plugins.market.open('com.lootlopk.app');
	navigator.app.exitApp();
}

var blockedView = function () {
	if (!versionChecked){
		bs.getAppVersion( function (data) {
			versionChecked = true;
			if ( data.version !== AppVersion ) {
				var message = 'Your App version is outdated. Please update your app from Playstore';
				if (navigator.notification) {
					navigator.notification.alert(
						  message,    // message
						  updateApp,       // callback
						  "LOOTLO.PK", // title
						  'OK'        // buttonName
					  );
				}else alert(message);
				location.hash = "/blocked";
			}else location.hash = "/home";
		});
	}
    $("#contents").html('');
};

var howWorksView = function () {
    $("#contents").load(pathVar+"how-works.html", function (e) {});
};

var catView = function () {
    sLdr();
    bs.getCategoriesMenu(function (r) {
    	$("#contents").load(pathVar+"categories-list.html", function (e) {
			r.goToCategory = function (arg) {location.hash = "/categories/"+arg.id+"/"+arg.name;}
            ko.cleanNode($("#contents").get(0));
            ko.applyBindings(r, $("#contents").get(0));
            hLdr();
        });
    });
};

var prodDet = function (productId) {
    $("#contents").load(pathVar+"prod-det.html", function (e) {

        bs.getProductDetails(productId, function (r) {
            r.allBunOptSel = ko.observable(false);
            r.productAttr = {
                variId: ko.observable(),
                attr: ko.observableArray(),
				attrLength: ko.observable(),
                isInStk: ko.observable(),
                //stock: ko.observable(),
                stockStatus: ko.observable(),
                minQty: ko.observable(),
                maxQty: ko.observable()

            };
			r.LootLo = function () {
				
				r.productAttr.attr([]);
                if ((r.productTyp() == "variable" || r.productTyp() == "bundle" ) && r.pc != r.productAttr.attrLength()){
                    $("#dvOutOfStockConf").css({"background-color":"#FE8282", "color":"white", "padding":"10px"});
					$("#dvOutOfStockConf").text('Please select an option that is not out of stock.').show();
					$('html, body').animate({
						scrollTop: $("#dvOutOfStockConf").offset().top
					}, 800);
                    return false;
				}
				if (r.productTyp() == "variable" || r.productTyp() == "bundle" ){
					$.each( r.productAttr.variId(), function( varikey, variValue ) {
						for (var key in r.attributes) {
							if (r.attributes[key]['variation_id'] ==  variValue){
								$.each( r.attributes[key]['attributes'], function( attrkey, attrValue ) { 
									r.productAttr.attr.push(attrValue);
								});
								break;
							}
						}
					});
				}
				manageCartExt(r);
				
            };
			
			r.addFav = function () {
				addToFavorites(r);
            };
			r.socialShare = function () {
				window.plugins.socialsharing.share('Check out this product I found:', null, null, r.permalink());
            };
			var string = r.contents();
			string = string.split('src="//').join('src="http://');
			string = string.replace(/width="\d+"/ig,'');
			string = string.replace(/height="\d+"/ig,'');
			r.contents(string);
            ko.cleanNode($("#contents").get(0));
            ko.applyBindings(r, $("#contents").get(0));
            var timer = new Timer($('#product-counter'), r.expireDate());


            //Plug Banner Slider
            var swiperdetail = new Swiper('.swiper-detail-page', {
                pagination: '.swiper-detail-pagination',
                grabCursor: true,
                autoplay: 2500,
                loop: true
            });
            initPhotoSwipeFromDOM('.photoswipe-gallery');
            
            if (r.productTyp() == "simple") {
				if (r.manageStock) r.productAttr.maxQty(r.purchaseLim);
				else r.productAttr.maxQty(999);
                r.productAttr.stockStatus(r.stock_status);
            }
            else if (r.productTyp() == "bundle") {
                bunProd(r);
            } else {
                bunProd(r);
            }
            hLdr();
        });
    });
};

var defGal = function () {
    if (!isAppBsy) {
        location.hash = "/home";
    }
};

var bunProd = function (r) {
	
	if (r.attributes.length > 0) {
		var attObj = {};
		var attCount = Object.keys(r.attributes[0].attributes).length;
		for (var attr in r.attributes) {
			var attributes = r.attributes[attr].attributes;				
			if (attCount == 1){
				attObj[attributes[Object.keys(attributes)[0]]] = {stock: r.attributes[attr].max_qty, variation_id: r.attributes[attr].variation_id};
			}else if (attCount == 2){
				if (!(attObj[attributes[Object.keys(attributes)[0]]]))
					attObj[attributes[Object.keys(attributes)[0]]] = {};
				attObj[attributes[Object.keys(attributes)[0]]][attributes[Object.keys(attributes)[1]]] = {stock: r.attributes[attr].max_qty, variation_id: r.attributes[attr].variation_id};
			}else if (attCount == 3){
				if (!(attObj[attributes[Object.keys(attributes)[0]]]))
					attObj[attributes[Object.keys(attributes)[0]]] = {};
				if (!(attObj[attributes[Object.keys(attributes)[0]]][attributes[Object.keys(attributes)[1]]]))
					attObj[attributes[Object.keys(attributes)[0]]][attributes[Object.keys(attributes)[1]]] = {};
				attObj[attributes[Object.keys(attributes)[0]]][attributes[Object.keys(attributes)[1]]][attributes[Object.keys(attributes)[2]]] = {stock: r.attributes[attr].max_qty, variation_id: r.attributes[attr].variation_id};
			}
		}
	}
    for (var i = 0; i < r.pc; i++) {
        if (r.attributes.length > 0) {
            for (var attrId in r.attributes[0].attributes) {
                var ctrlText = [];
                var ctrlValue = [];

                for (var key in r.attributes) {
                    var variObj = r.attributes[key];

                    if (variObj.variation_is_visible) {
                        ctrlText.push(variObj.attributes[attrId]);
                        ctrlValue.push(variObj.variation_id);
                    }
                }

                var dynCtrl = "<select id='" + attrId + i + "' class='form-control ctrl-attr" + i.toString() + "' data-pack='"+i+"'  ></select>";
                $("#dvDynamicControls").append(dynCtrl);
                var ctrl = $("#" + attrId + i);

                var ctrlTextSort = distFun(ctrlText);
                if (attrId.split('_').length == 2) {
                    ctrlTextSort.unshift(attrId.split('_')[1] + " ↓");
                } else if (attrId.split('_').length == 1) {
                    ctrlTextSort.unshift(attrId.split('_')[0] + " ↓");
                }
                for (var key in ctrlTextSort) {
					if (key == 0)
						var value = '';
					else
						var value = ctrlTextSort[key];
                    ctrl.append($('<option>', {
                        value: value,
                        text: ctrlTextSort[key]
                    }));
                }
				var isCompairCount = 0;
                ctrl.change(function (a, b, c) {
					$("#dvStockInfo").html('').hide();
					$("#dvOutOfStockConf").html('').hide();
					var pack = this.getAttribute("data-pack");
					for (var att in r.attributes[0].attributes){
						if (!$('#'+att+pack).val())
							return false;
					}
					if (attCount == 1){
						var selAtt1;
						selAtt1 = $('#'+Object.keys(attributes)[0]+pack).val();
						if (attObj[selAtt1]['stock'] == 0){
							$("#dvStockInfo").css({"background-color":"#FE8282", "color":"white", "padding":"10px"});
							$("#dvStockInfo").html('Out of Stock').show();
							return false;
						}
						else{
							$("#dvStockInfo").css({"background-color":"green", "color":"white", "padding":"10px"});
							$("#dvStockInfo").html(attObj[selAtt1]['stock']+' in Stock').show();
							if (r.productAttr.variId())
								var varObj = r.productAttr.variId();
							else
								var varObj = {};
							varObj['pack'+pack] = attObj[selAtt1]['variation_id'];
							r.productAttr.variId(varObj);
							r.productAttr.maxQty(attObj[selAtt1]['stock']);
						}
					}else if (attCount == 2){
						var selAtt1,selAtt2;
						selAtt1 = $('#'+Object.keys(attributes)[0]+pack).val();
						selAtt2 = $('#'+Object.keys(attributes)[1]+pack).val();
						if (!(selAtt2 in attObj[selAtt1]) || attObj[selAtt1][selAtt2]['stock'] == 0){
							$("#dvStockInfo").css({"background-color":"#FE8282", "color":"white", "padding":"10px"});
							$("#dvStockInfo").html('Out of Stock').show();
							return false;
						}
						else{
							$("#dvStockInfo").css({"background-color":"green", "color":"white", "padding":"10px"});
							$("#dvStockInfo").html(attObj[selAtt1][selAtt2]['stock']+' in Stock').show();
							if (r.productAttr.variId())
								var varObj = r.productAttr.variId();
							else
								var varObj = {};
							varObj['pack'+pack] = attObj[selAtt1][selAtt2]['variation_id'];
							r.productAttr.variId(varObj);
							r.productAttr.maxQty(attObj[selAtt1][selAtt2]['stock']);
						}
					}else if (attCount == 3){
						var selAtt1,selAtt2, setAtt3;
						selAtt1 = $('#'+Object.keys(attributes)[0]+pack).val();
						selAtt2 = $('#'+Object.keys(attributes)[1]+pack).val();
						selAtt3 = $('#'+Object.keys(attributes)[2]+pack).val();
						if (!(selAtt3 in attObj[selAtt1][selAtt2]) || attObj[selAtt1][selAtt2][selAtt3]['stock'] == 0){
							$("#dvStockInfo").css({"background-color":"#FE8282", "color":"white", "padding":"10px"});
							$("#dvStockInfo").html('Out of Stock').show();
							return false;
						}
						else{
							$("#dvStockInfo").css({"background-color":"green", "color":"white", "padding":"10px"});
							$("#dvStockInfo").html(attObj[selAtt1][selAtt2][selAtt3]['stock']+' in Stock').show();
							if (r.productAttr.variId())
								var varObj = r.productAttr.variId();
							else
								var varObj = {};
							varObj['pack'+pack] = attObj[selAtt1][selAtt2][selAtt3]['variation_id'];
							r.productAttr.variId(varObj);
							r.productAttr.maxQty(attObj[selAtt1][selAtt2][selAtt3]['stock']);
						}
					}
					
					r.productAttr.attrLength(Object.keys(r.productAttr.variId()).length);
					
                });

            }
        }
    }
};

var postDealView = function () {
    $("#contents").load(pathVar+"post-deal.html", function (e) {
        var vm = new PostDeal("", "", "", "", "", "");
        ko.cleanNode($("#contents").get(0));
        ko.applyBindings(vm, $("#contents").get(0));
    });
};

var contactUsView = function () {
    $("#contents").load(pathVar+"contact-us.html", function (e) {
        var vm = new ContactUs("", "", "", "");
		vm.callToUs = function (){
			phonedialer.dial('021111566856');
		}
        ko.cleanNode($("#contents").get(0));
        ko.applyBindings(vm, $("#contents").get(0));
    });
};

var selRegion = function () {
    $("#contents").load(pathVar+"select-region.html", function (e) {
        ko.cleanNode($("#contents").get(0));
        ko.applyBindings(null, $("#contents").get(0));
        $(".select-region").on('click', function () {
            event.preventDefault();
            var city = $(this).data("location");
			localStorage.setItem('ll_city', city);
			bs.servicsOpt.city = city;
			location.hash = "/home";
            spm("City has been changed to " + bs.servicsOpt.city, 'info');
        });
    });
};

var addToFavorites = function (model) {
	if (model != undefined) {
		var newDeal = true;
		if (myFav.data().length > 0) {
			var source = myFav.data();
			for (var i = 0; i < source.length; i++) {
				if (source[i].productId === model.id) {
					newDeal = false;
				}
			}
		}
		if (newDeal){
			var favDeal = {
				id:999,
				productId:model.id,
				name:model.name(),
				title:model.title(),
				priceDiscount:model.priceDiscount(),
				price:model.price(),
				location:model.location(),
				imgUrl:model.imgUrl()
			};
			favDeal.removeItem = function (datax) {
				myFav.data.remove(this);
				$("#" + this.productId).remove();
				localStorage.setItem('myFavorites', JSON.stringify(myFav.data()));
			};

			favDeal.prodDet = function (data) {
				location.hash = "/prod-det/"+this.productId;
			};
			myFav.data().push(favDeal);
			localStorage.setItem('myFavorites', JSON.stringify(myFav.data()));
		}
	}
	location.hash = "/my-favorites";
}

var myFavorites = function (model) {
    $("#contents").load(pathVar+"favorites.html", function (e) {
		ko.cleanNode($("#contents").get(0));
		ko.applyBindings(myFav, $("#contents").get(0));
		$("#dvFavList").show();
		removeItem = function (datax) {
			myFav.data.remove(this);
			$("#" + this.productId()).remove();
		};
    });
};

var manageCart = function (model) {
    $("#contents").load(pathVar+"man-cart.html", function (e) {
		myCart.continueShopping = function () { location.hash = "/home"; };
		ko.cleanNode($("#contents").get(0));
		ko.applyBindings(myCart, $("#contents").get(0));
    });
};

var manageCartExt = function (model) {
	var cartVM = new Cart(999, model.id, model.name(), model.title(), model.priceDiscount(), 1, model.priceDiscount() , model.imgUrl(), model.productAttr, model.productTyp(), model.isVirtual());
    cartVM.qtyChange = function (data) {
        if (parseInt(this.qty()) >= parseInt(cartVM.productAttr.maxQty())) {
            myCart.total(parseInt(myCart.total()) - parseInt(this.total()));
			this.qty(cartVM.productAttr.maxQty());
            this.total(parseInt(this.qty()) * this.price());
			myCart.total(parseInt(myCart.total()) + parseInt(this.total()));
            return;
        } else {
			if (!this.qty() || parseInt(this.qty()) == 0) this.qty(1);
			myCart.total(parseInt(myCart.total()) - parseInt(this.total()));
            this.total(parseInt(this.qty()) * this.price());
			myCart.total(parseInt(myCart.total()) + parseInt(this.total()));
        }
    };

    cartVM.removeItem = function (datax) {
        myCart.data.remove(this);
        location.hash = "/cart";
    };

    cartVM.prodDet = function (data) { location.hash = "/prod-det/"+this.productId(); };

    myCart.proceedCheckout = function () { location.hash = "/checkout"; }; 

    if (myCart.data().length > 0) {
        var fci = fndCrt(myCart.data(), model);
        if (fci != null) {
            fci.qty(parseInt(fci.qty()) + 1);
            fci.total(fci.qty() * fci.price());
			myCart.total (parseInt(myCart.total()) + parseInt(fci.price()));
        } else {
            myCart.data().push(cartVM);
			myCart.total (parseInt(myCart.total()) + parseInt(cartVM.total()));
        }
    } else {
        myCart.data().push(cartVM);
		myCart.total = ko.observable(cartVM.total());
    }
	location.hash = "/cart";
};

var selAdd = null;
var pmtCheckout = function () {
    $("#contents").load(pathVar+"pmt-checkout.html", function (e) {
        sLdr();
        var vm = new PaymentCheckout(null, myCart.data(), "Free Shipping");
		if (myCart.data().length > 0) {
			for (var i = 0; i < myCart.data().length; i++) {
				if (myCart.data()[i].isVirtual() === 'yes')
				vm.isVirtual(1);
			}
		}
        if (userInfo != undefined) {
            bs.getMyAddress(userInfo.ID, function (r) {
                vm.myAddress = r;
                vm.myAddress.forEach(function () {
                    
                    this.addrSel2 = function (obj, event) {
                        $(".my-address").css("background-color", "#ffffff");
                        var tx = $(event.currentTarget);
                        var idx = tx.attr("idx");
                        var tmp = tx.parent().parent().parent().find("#" + idx).css("background-color", "#E39595");
                        selAdd = new BillingAddress(obj.id, obj.billing_first_name, obj.billing_last_name, obj.billing_email, obj.billing_phone, obj.billing_address_1, obj.billing_state, obj.billing_country, null);
                    };
                    
                    this.addressSelection = function (obj, event) {
                        $(".my-address").css("background-color", "#ffffff");
                        event.currentTarget.style.background = "#E39595";
                        selAdd = new BillingAddress(obj.id, obj.billing_first_name, obj.billing_last_name, obj.billing_email, obj.billing_phone, obj.billing_address_1, obj.billing_state, obj.billing_country, null);
						resetShipment(vm,obj.billing_country);
                    };
                    this.deleteAddress = function (da) {
                        sLdr();
                        bs.deleteAddress(userInfo.ID, da, function (response) {
                            location.hash = "/checkout";
                            spm(response.message, 'info');
                            hLdr();
                        });
                    };
                    this.editAddress = function (ea) {
                        event.preventDefault();
                        var ta = new BillingAddress(ea.id, ea.billing_first_name, ea.billing_last_name, ea.billing_email, ea.billing_phone, ea.billing_address_1, ea.billing_state, ea.billing_country, null);
                        editAddr(ta);
                    };
                });
                var defAdd = fndAddr(r, 1);
                if (defAdd != null) {
                    selAdd = new BillingAddress(defAdd.idx, defAdd.billing_first_name, defAdd.billing_last_name, defAdd.billing_email, defAdd.billing_phone, defAdd.billing_address_1, defAdd.billing_state, defAdd.billing_country, null);
                }
				bs.getUserFunds(userInfo.ID, function (r) {
					if (r.funds)
						vm.funds(r.funds);
				});
                pmtCheckExt(vm);
            });
        } else {

            vm.isNewUser(true);

            $("#dvNewUser").load(pathVar+"new-user.html", function (e) {

                selAdd = new BillingAddress(null, null, null, null, null, null, null, null, null);

                selAdd.citySelectedValue = ko.observable();
                selAdd.areaSelectedValue = ko.observable();
                selAdd.showArea = ko.observable(false);
                selAdd.citySelectedValue.subscribe(function (newValue) {
                    if (newValue == "KARACHI") {
                        selAdd.showArea(true);
                        $("#dvShowArea2").show();
                    } else {
                        selAdd.showArea(false);
                        $("#dvShowArea2").hide();
                    }
					resetShipment(vm,newValue);
                });

                ko.cleanNode($("#dvNewUser").get(0));
                ko.applyBindings(selAdd, $("#dvNewUser").get(0));

            });

            doCheckout = true;
            $("#dvRetCust").show();
            pmtCheckExt(vm);
        }

        isPMode = true;
    });
};

var pmtCheckExt = function (vm) {

    resetShipment(vm);
    vm.paymentType.subscribe(function (newValue) {

        switch (newValue) {
            case "Account Funds":
                vm.pmtCod("accountfunds");
                break;
			case "Cash on Delivery":
                vm.pmtCod("cod");
                break;
            case "Direct Bank Transfer":
                vm.pmtCod("bacs");
                break;
            case "Easy Paisa":
                vm.pmtCod("wcLpep");
                break;
			case "IR Online Payment":
                vm.pmtCod("wcLpir");
                break;
            case "Online Payment":
                vm.pmtCod("wcLpg");
                break;
            case "Mobicash":
                vm.pmtCod("wcLpmc");
                break;
            case "UBL Omni":
                vm.pmtCod("wcLpuo");
                break;
            default:
        }
    });
    
    // Applicable if customers first order from mobile app
    checkAppDiscount(userInfo, vm);
    //end check discount method 

    vm.placeOrder = function () {
        if (userInfo != undefined) {
            if (selAdd != null) {
                selAdd.confirmPwd("invalid");
                selAdd.pwd("invalid");
                bs.placeOrder(userInfo.ID, selAdd, vm, function (r) {
                    if (r.post != undefined) {
                        var p = r.post;
                        var op = new OrderPlaced(p.order, p.order_date, vm.orderTotal(), p.payment_method, r.message, myCart.data(), vm.shippingCost(), vm.orderDis(), selAdd, userInfo);
                        if ((op.paymentMethod() == "Online Payment" || op.paymentMethod() == "Instant Redemption Through Online Payment") && op.orderId() != null) {
                            onlinePmt(op);
                        } else {
                            orderPlacedVM(op);
                        }
                    }
                });
            } else {
                spm("Please select address", 'danger');
            }
        } else {
            if (vm.isNewUser()) {
                bs.placeOrder(0, selAdd, vm, function (r) {
                    if (r.post != undefined) {
                        var p = r.post;
                        var op = new OrderPlaced(p.order, p.order_date, vm.orderTotal(), p.payment_method, r.message, myCart.data(), vm.shippingCost(), vm.orderDis(), selAdd, userInfo);
                        if (op.paymentMethod() == "Online Payment" && op.orderId() != null) {
                            onlinePmt(op);
                        } else {
                            orderPlacedVM(op);
                        }
                    }
                });
            } else {
                spm("Please log in first", 'danger');
            }
        }
    };
	vm.goToSignin = function() { location.hash = "/signin"; };
	vm.cancel = function() { location.hash = "/home"; };
    ko.cleanNode($("#contents").get(0));
    ko.applyBindings(vm, $("#contents").get(0));

    if (selAdd != null) {
        $("#dvMyAddress ul li#" + selAdd.id()).css("background-color", "#E39595");
    }

    $("#hlCoup").click(function (e) {
        e.preventDefault();
        $("#dvCoup").show();
    });

    if (userInfo != undefined) {
        $("#dvMyAddress").show();
        $("#hlAddAddress").click(function (e) {
            e.preventDefault();
            location.hash = "/add-address";
        });
    }

    hLdr();
};

var orderPlacedVM = function (vm) {

	location.hash = "/order-placed";
    $("#contents").load(pathVar+"order-placed.html", function (e) {

        ko.cleanNode($("#contents").get(0));
        ko.applyBindings(vm, $("#contents").get(0));

        switch (vm.paymentMethod()) {
            case "Account Funds":
                $(".tc").hide();
                $("#dvAF").show();
                break;
			case "Cash on Delivery":
                $(".tc").hide();
                $("#dvCOD").show();
                break;
            case "Direct Bank Transfer":
                $(".tc").hide();
                $("#dvDBT").show();
                break;
            case "Easy Paisa":
                $(".tc").hide();
                $("#dvEP").show();
                break;
			case "Instant Redemption Through Online Payment":
                $(".tc").hide();
                $("#dvIROP").show();
                break;
            case "Online Payment":
                $(".tc").hide();
				$("#dvOP").show();
                break;
            case "Mobicash":
                $(".tc").hide();
                $("#dvMC").show();
                break;
            case "UBL Omni":
                $(".tc").hide();
                $("#dvUBLO").show();
                break;
            default:
        }

        doCheckout = false;
        isPMode = false;
        selAdd = null;

        myCart.data([]);
        hLdr();

    });
};

var myAccount = function (cv) {
	location.hash = "/profile";
    if (userInfo != undefined) {
        sLdr();
        var vm = new MyAccount(userInfo, null, null, []);
        bs.getRecentOrders(userInfo.ID, function (ro) {
           	$("#contents").load(pathVar+"user-profile.html", function (e) {
                var hasOrders = false;
                if (ro.orders != null) {
                    var toArray = toObjectArray(ro.orders);
                    vm.recentOrders.pushAll(toArray);
                    hasOrders = true;
                }

                vm.accountSettings = new AccountSettings(userInfo.ID, userInfo.first_name, userInfo.last_name, "", "");
                vm.accountSettings.updateacc = function () {
                    sLdr();
                    bs.updateAccountSettings(userInfo.ID, vm.accountSettings, function (ras) {
                        spm(ras.msg, 'success');
                        hLdr();
                    });
                };

                bs.getMyAddress(userInfo.ID, function (ra) {

                    $.map(ra, function (value, index) {
                       var ta = new BillingAddress(value.id, value.billing_first_name, value.billing_last_name, value.billing_email, value.billing_phone, value.billing_address_1, value.billing_state, value.billing_country, null);
                        ta.deleteAddress = function (a) {
                            sLdr();
                            bs.deleteAddress(userInfo.ID, a, function (response) {
                                vm.myAddress.remove(a);
                                spm(response.message, 'success');
                                hLdr();
                            });
                        };
                        ta.editAddress = function (ea) {
                            editAddr(ea);
                        };
                        vm.editAddr = ta;
						vm.myAddress.push(ta);
                    });

                    ko.cleanNode($("#contents").get(0));
                    ko.applyBindings(vm, $("#contents").get(0));
                    $("#hlAddAddress").click(function (event) {
                        event.preventDefault();
                        location.hash = "/add-address";
                    });
                    hLdr();
                });
            });
        });
    } else {
        spm("Please Sign In to view your Account Information", 'danger');
        location.hash = "/signin";
    }
};

var addAddrVM = function () {

    $("#contents").load(pathVar+"add-address.html", function (e) {

        var addAddr = new BillingAddress(null,null,null,null,null,null,null,null,null);

        addAddr.citySelectedValue = ko.observable();
        addAddr.areaSelectedValue = ko.observable();
        addAddr.showArea = ko.observable(false);
        addAddr.citySelectedValue.subscribe(function (newValue) {
            if (newValue == "KARACHI") {
                addAddr.showArea(true);
                $("#dvShowArea2").show();
            } else {
                addAddr.showArea(false);
                $("#dvShowArea2").hide();
            }
        });

        addAddr.submitAddress = function (a, b, c) {
			if (addAddr.isValid()) {
				sLdr();
				bs.postAddress(userInfo.ID, addAddr, function (data) {
					if (data.status == "success") {
						spm("Billing Address Saved", 'success');
						hLdr();

						if (isPMode) {
							location.hash = "/checkout";
						} else {
							myAccount("myAddress");
						}
					}
				});
			}
        };
		addAddr.isValid = function () {
			var iValid = false;

			iValid = addAddr.firstName.isValid() && addAddr.lastName.isValid() && addAddr.email.isValid() &&
				addAddr.phone.isValid() && addAddr.address.isValid();

			if (!iValid) {
				spm("Please specify valid information", 'danger');
			}

			return iValid;
		};

        ko.cleanNode($("#contents").get(0));
        ko.applyBindings(addAddr, $("#contents").get(0));

    });
};

var catGallery = function (selectedCategory, cId) {
    sLdr();
    bs.getProductsByCategory(cId, function (r) {
    	$("#contents").load(pathVar+"gallery.html", function (e) {
        	var vm = new Deal(selectedCategory, r.data);
            vm.dealTypes = ko.observableArray(['Recent', 'Hot', 'Featured']);
			vm.goToDeals = function(dealType) { location.hash = "/deals/"+dealType; };
			vm.goToProduct = function(deal){ location.hash = "/prod-det/"+deal.pId; };

            ko.cleanNode($("#contents").get(0));
            ko.applyBindings(vm, $("#contents").get(0));
            hLdr();
        });
    });
};

var searchDeal = function (sText) {
	sLdr();
	//var search_text = $('#search_field').val();
	
    bs.searchProduct(sText, function (r) {
    	$("#contents").load(pathVar+"gallery.html", function (e) {
        	var vm = new Deal(sText, r.data);
            vm.dealTypes = ko.observableArray(['Recent', 'Hot', 'Featured']);
			vm.goToDeals = function(dealType) { location.hash = "/deals/"+dealType; };
			vm.goToProduct = function(deal){ location.hash = "/prod-det/"+deal.pId; };

            ko.cleanNode($("#contents").get(0));
            ko.applyBindings(vm, $("#contents").get(0));
            hLdr();
        });
        return (false);
    });
}

var editAddr = function (editModel) {
	location.hash = "/edit-address";
    $("#contents").load(pathVar+"edit-address.html", function (e) {

        editModel.citySelectedValue = ko.observable(editModel.city());

        editModel.showArea = ko.observable(false);

        editModel.citySelectedValue.subscribe(function (newValue) {
            if (newValue == "KARACHI") {
                editModel.showArea(true);
                $("#dvShowArea").show();
            } else {
                editModel.areaSelectedValue("");
                editModel.area("");
                editModel.showArea(false);
                $("#dvShowArea").hide();
            }
            editModel.city(newValue.toUpperCase());
        });

        editModel.submitAddress = function () {
			if (editModel.isValid()){
				sLdr();
				editModel.area(editModel.areaSelectedValue().toUpperCase());
				bs.editAddress(userInfo.ID, editModel, function (r) {
					if (r.status == "success") {
						spm(r.message, 'success');
						if (isPMode) {
							location.hash = "/checkout";
						} else {
							myAccount("#myAddress");
						}
					}
				});
			}
        };

        if (editModel.area() != null && editModel.area() != "") {
            editModel.areaSelectedValue = ko.observable(editModel.area().toUpperCase());
            editModel.showArea(true);
        }
        else {
            editModel.areaSelectedValue = ko.observable();
            editModel.showArea(false);
        }
		editModel.isValid = function () {
			var iValid = false;

			iValid = editModel.firstName.isValid() && editModel.lastName.isValid() && editModel.email.isValid() &&
				editModel.phone.isValid() && editModel.address.isValid();

			if (!iValid) {
				spm("Please specify valid information", 'danger');
			}

			return iValid;
		};

        ko.cleanNode($("#contents").get(0));
        ko.applyBindings(editModel, $("#contents").get(0));

    });
};

var resetShipment = function (vm,shippingCity) {
    var subset = cloneko(myCart.data(), ["productId", "qty"]);
    sLdr();
    bs.shippingCost(JSON.stringify(subset),shippingCity, function (resp) {
        vm.calcShippingCost(resp.shipping_total);
        hLdr();
    });
};

var checkAppDiscount = function (userInfo, vm){
    bs.checkdiscountfirstorder(userInfo, function(result){
        if (result.status == 'success'){
            vm.orderDis(Math.round(parseFloat(vm.orderTotal()) * 0.1));
            vm.orderTotal(parseFloat(vm.orderTotal()) - vm.orderDis());
            vm.vdis(true);
            $("#dvCoup").hide();
        }
    });
};

var signOut = function () {
    userInfo = null;
	localStorage.removeItem('userInfo');
	isLoggedIn(false);
    myCart.data([]);
    doCheckout = false;
    spm("Signed Out Successfully.", 'success');
	location.hash = "/home"; 
};

var varProd = function (r) {

    if (r.attributes.length > 0) {
        for (var attrId in r.attributes[0].attributes) {

            var ctrlText = [];
            var ctrlValue = [];

            var dynCtrl = "<select id='" + attrId + "' class='form-control ctrl-attr'  style='width:100%; padding:6px 12px; height:34px; font-size:14px; line-height:1.4px; color:#555; border :1px solid #ccc; border-radius:4px; margin-bottom:8px;'></select><br/>";
            $("#dvDynamicControls").append(dynCtrl);
            var ctrl = $("#" + attrId);
            ctrl.change(function (a, b, c) {
                var selValue = this.value;
                if (selValue.indexOf("?") == -1) {
                    var allSelected = true;
                    var ctrlAttrLength = $(".ctrl-attr").length;
                    $(".ctrl-attr").each(function () {
                        if (this.value.indexOf("?") > -1) {
                            allSelected = false;
                        }
                    });

                    if (allSelected) {
                        for (var key in r.attributes) {
                            var obj = r.attributes[key];
                            var isCompairFound = false;
                            var isCompairCount = 0;
                            r.productAttr.attr([]);

                            for (var aKey in obj.attributes) {
                                isCompairFound = $("#" + aKey).val() == obj.attributes[aKey];
                                if (isCompairFound) {
                                    isCompairCount++;
                                    r.productAttr.attr.push(new KP(aKey, obj.attributes[aKey]));
                                    if (isCompairCount == ctrlAttrLength) {
                                        r.productAttr.variId(obj.variation_id);
                                    }
                                }
                            }

                            if (isCompairCount == ctrlAttrLength) {
                                isCompairCount = 0;
                                isCompairFound = false;
                                r.productAttr.isInStk(obj.is_in_stock);
                                r.productAttr.minQty(obj.min_qty);
                                r.productAttr.maxQty(obj.max_qty);

                                if (r.productAttr.isInStk) {
                                    $("#dvStockInfo > div").html(obj.availability_html);
                                    $("#dvOutOfStockConf > div").empty().fadeOut();
                                } else {
                                    $("#dvStockInfo > div").html(obj.availability_html);
                                }
                                break;
                            } else {
                                $("#dvStockInfo > div").empty();
                            }
                        }
                    }
                } else {
                    $("#dvStockInfo > div").empty();
                }
            });

            for (var key in r.attributes) {
                var obj = r.attributes[key];

                if (obj.variation_is_visible) {
                    ctrlText.push(obj.attributes[attrId]);
                    ctrlValue.push(obj.variation_id);
                }
            }

            var ctrlTextSort = distFun(ctrlText);
            if (attrId.split('_').length == 2) {
                ctrlTextSort.unshift(attrId.split('_')[1] + " ↓");
            } else if (attrId.split('_').length == 1) {
                ctrlTextSort.unshift(attrId.split('_')[0] + " ↓");
            }

            for (var key in ctrlTextSort) {
                ctrl.append($('<option>', {
                    value: ctrlTextSort[key],
                    text: ctrlTextSort[key]
                }));
            }
        }
    }
};

var onlinePmt = function (oVM) {
	location.hash = '/order-online';
    $("#contents").load(pathVar+"order-online.html", function (e) {
        var vmcc = new CreditCrd(oVM.orderId(), null, null, null, null, oVM);
        ko.cleanNode($("#contents").get(0));
        ko.applyBindings(vmcc, $("#contents").get(0));
		hLdr();
    });
};
